@echo off
:: Usage
:: package_cloud.cmd project.json

SETLOCAL EnableDelayedExpansion

:: replace by your valid path to UiPath 
set UiPathRoot=C:\Users\%USERNAME%\AppData\Local\Programs\UiPath\Studio

call %~dp0\set_version.cmd

:: Read type of project
FOR /f "tokens=2 delims=: " %%G IN ('type %1 ^| find "outputType"') DO (
set x=%%G 
set _type=!x:~1,-3!
set _type=!_type: =!
)

:: Read name of project
FOR /f "tokens=2 delims=: " %%G IN ('type %1 ^| find "description"') DO (
set x=%%G 
set PROJECT=!x:~1!
set PROJECT=!PROJECT: =!
)

if "%_type%" NEQ "Process" (
echo.
echo Project %_project% is not Process type
goto ERROR 
) 

cls
echo.
echo WARNING
echo.
echo This will package and deploy project %PROJECT% to Orchestrator
echo.
echo.
set _instance=PROD
echo.
choice /M "Deploy project %PROJECT% to Orchestrator instance %_instance%?"
if %ERRORLEVEL%==2 goto END

:: make temp folder for packaging
:uniqLoop
set "_pkgFolder=%tmp%\UiPath~%RANDOM%.tmp"
if exist "%_pkgFolder%" goto :uniqLoop
md "%_pkgFolder%"

:: package project
powershell -command "cd '%UiPathRoot%'; .\UiRobot.exe -pack '%1' -o '%_pkgFolder%' -v '%_version%' " > %~dp0\output.txt
:: validate packaging result
find /C "Project published successfully."  %~dp0\output.txt > null
IF %ERRORLEVEL% NEQ 0 (
    echo ERROR publishing project %PROJECT%
    type %~dp0\output.txt 
    goto ERROR
)
:: publish to cloud Orchestrator
powershell -file %~dp0\package_cloud.ps1 -pkgDir "%_pkgFolder%"

:ERROR
echo Waiting 30sec
PING -n 31 127.0.0.1>nul

:END
rd /Q /S "%_pkgFolder%"
del /Q %~dp0\output.txt 
exit

